// CustomizeDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "crystalcpuid.h"
#include "CrystalCPUIDDlg.h"
#include "CustomizeDlg.h"
#include "LcdSetting.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern int gLanguage;
extern CBitmap gBackBitmap;
extern CBrush gBackBrush;
extern COLORREF gTextColor;
extern BOOL gFlagBack;

static CCrystalCPUIDDlg* P;

/////////////////////////////////////////////////////////////////////////////
// CCustomizeDlg Dialog

CCustomizeDlg::CCustomizeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCustomizeDlg::IDD, pParent)
{
	P = (CCrystalCPUIDDlg*)pParent;
	P->GetClientRect(&m_rect);
	//{{AFX_DATA_INIT(CCustomizeDlg)
	m_FileName = _T("");
	m_WindowSize = _T("");
	m_ImageSize = _T("");
	m_TextColor = _T("");
	m_Gray = FALSE;
	m_LcdOnRgb = RGB( 0, 0, 0 );
	m_LcdOffRgb = RGB( 0, 0, 0 );
	m_LcdGridRgb = RGB( 0, 0, 0 );
	m_LcdGrid = _T("");
	m_LcdOff = _T("");
	m_LcdOn = _T("");
	//}}AFX_DATA_INIT
}

void CCustomizeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCustomizeDlg)
	DDX_Control(pDX, IDC_RTC_TOPMOST, m_RtcTopMost);
	DDX_Control(pDX, IDC_LCD_SAMPLE_9, m_LcdSample9);
	DDX_Control(pDX, IDC_LCD_SAMPLE_8, m_LcdSample8);
	DDX_Control(pDX, IDC_LCD_SAMPLE_7, m_LcdSample7);
	DDX_Control(pDX, IDC_LCD_SAMPLE_6, m_LcdSample6);
	DDX_Control(pDX, IDC_LCD_SAMPLE_5, m_LcdSample5);
	DDX_Control(pDX, IDC_LCD_SAMPLE_4, m_LcdSample4);
	DDX_Control(pDX, IDC_LCD_SAMPLE_3, m_LcdSample3);
	DDX_Control(pDX, IDC_LCD_SAMPLE_2, m_LcdSample2);
	DDX_Control(pDX, IDC_LCD_SAMPLE_10, m_LcdSample10);
	DDX_Control(pDX, IDC_LCD_SAMPLE_1, m_LcdSample1);
	DDX_Control(pDX, IDC_INTERVAL_TIME, m_IntervalTime);
	DDX_Control(pDX, IDC_LCD_SAMPLE, m_LcdSample);
	DDX_Control(pDX, IDC_GRAY, m_GrayC);
	DDX_Text(pDX, IDC_FILE_NAME, m_FileName);
	DDX_Text(pDX, IDC_WINDOW_SIZE, m_WindowSize);
	DDX_Text(pDX, IDC_IMAGE_SIZE, m_ImageSize);
	DDX_Text(pDX, IDC_TEXT_COLOR, m_TextColor);
	DDX_Check(pDX, IDC_GRAY, m_Gray);
	DDX_Text(pDX, IDC_LCD_GRID, m_LcdGrid);
	DDX_Text(pDX, IDC_LCD_OFF, m_LcdOff);
	DDX_Text(pDX, IDC_LCD_ON, m_LcdOn);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCustomizeDlg, CDialog)
	//{{AFX_MSG_MAP(CCustomizeDlg)
	ON_BN_CLICKED(IDC_SELECT_FILE, OnSelectFile)
	ON_BN_CLICKED(IDC_SELECT_COLOR, OnSelectColor)
	ON_BN_CLICKED(IDC_CLEAR, OnClear)
	ON_BN_CLICKED(IDC_GRAY, OnGray)
	ON_BN_CLICKED(IDC_SELECT_LCD_ON, OnSelectLcdOn)
	ON_BN_CLICKED(IDC_SELECT_LCD_OFF, OnSelectLcdOff)
	ON_BN_CLICKED(IDC_SELECT_LCD_GRID, OnSelectLcdGrid)
	ON_BN_CLICKED(IDC_RTC_HELP, OnRtcHelp)
	ON_CBN_SELCHANGE(IDC_INTERVAL_TIME, OnSelchangeIntervalTime)
	ON_BN_CLICKED(IDC_RTC_NO_LOAD, OnRtcNoLoad)
	ON_BN_CLICKED(IDC_RTC_WITH_LOAD, OnRtcWithLoad)
	ON_BN_CLICKED(IDC_LCD_SAMPLE_1, OnLcdSample1)
	ON_BN_CLICKED(IDC_LCD_SAMPLE_2, OnLcdSample2)
	ON_BN_CLICKED(IDC_LCD_SAMPLE_3, OnLcdSample3)
	ON_BN_CLICKED(IDC_LCD_SAMPLE_4, OnLcdSample4)
	ON_BN_CLICKED(IDC_LCD_SAMPLE_5, OnLcdSample5)
	ON_BN_CLICKED(IDC_LCD_SAMPLE_6, OnLcdSample6)
	ON_BN_CLICKED(IDC_LCD_SAMPLE_7, OnLcdSample7)
	ON_BN_CLICKED(IDC_LCD_SAMPLE_8, OnLcdSample8)
	ON_BN_CLICKED(IDC_LCD_SAMPLE_9, OnLcdSample9)
	ON_BN_CLICKED(IDC_LCD_SAMPLE_10, OnLcdSample10)
	ON_BN_CLICKED(IDC_RTC_TOPMOST, OnRtcTopmost)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CCustomizeDlg::OnCancel() 
{
	CDialog::OnCancel();
}

void CCustomizeDlg::OnOK() 
{
	CDialog::OnOK();
}


static void InitLcdSample(CMatrixStatic& ctrl,COLORREF grid, COLORREF on, COLORREF off);

void InitLcdSample(CMatrixStatic& ctrl, COLORREF grid, COLORREF on, COLORREF off)
{
	ctrl.SetText("*");
	ctrl.SetNumberOfLines(1);
	ctrl.SetXCharsPerLine(1);
	ctrl.SetSize(CMatrixStatic::LARGE);
	ctrl.SetDisplayColors( grid, on, off );
	ctrl.AdjustClientYToSize(1);
	ctrl.AdjustClientXToSize(1);
	ctrl.SetAutoPadding(true);
}

BOOL CCustomizeDlg::OnInitDialog() 
{
	CDialog::OnInitDialog();

//////////////////////////////////////////////
// Background
//////////////////////////////////////////////
	char str[MAX_PATH];
	GetPrivateProfileString("Setting","BackgroundImage","",str,MAX_PATH,P->m_ini);
	m_FileName = str;

	GetPrivateProfileString("Setting","Gray","0",str,MAX_PATH,P->m_ini);
	if( atoi(str) == 0 ){
		m_Gray = FALSE;
	}else{
		m_Gray = TRUE;
	}

	GetPrivateProfileString("Setting","TextColor","",str,MAX_PATH,P->m_ini);
	if( strcmp(str,"") == 0){
		gTextColor = ::GetSysColor(COLOR_WINDOWTEXT);
	}else{
		gTextColor = atoi(str);
	}
	m_TextColor.Format("RGB( %d, %d, %d )",
		gTextColor & 0x000000FF,
		(gTextColor & 0x0000FF00) >> 8,
		(gTextColor & 0x00FF0000) >> 16
		);
	
	if( ! m_FileName.IsEmpty() && ( Dib.LoadBmp(m_FileName)
#ifdef USEPNG
		|| Dib.LoadPng(m_FileName)
#endif
#ifdef USEJPEG
		|| Dib.LoadJpeg(m_FileName)
#endif
		)
	)
	{
		m_ImageSize.Format("%d x %d x %d", Dib.Width(), Dib.Height(), Dib.Depth() ) ;
		m_GrayC.EnableWindow( Dib.Depth() == 24 );
		Dib.Destroy();
	}

	m_WindowSize.Format("%d x %d", m_rect.right, m_rect.bottom);

//////////////////////////////////////////////
// LCD ( Real Time Clock / About )
//////////////////////////////////////////////
	m_LcdSample.SetText("\
CPU\
MMX\
SSE\
HTT\
SDR\
DDR\
QDR\
***\
abc\
def\
ghi\
jkl\
mno\
pqr\
stu\
vwx\
yz.\
***\
ABC\
DEF\
GHI\
JKL\
MNO\
PQR\
STU\
VWX\
YZ_\
***\
012\
345\
678\
9$#\
+-%\
!@|\
***\
***\
777\
***\
***\
");

		
	GetPrivateProfileString("Setting","LcdGrid",DEFAULT_LCD_GRID,str,256,P->m_ini);
	if( strcmp(str,"") != 0 ){
		m_LcdGridRgb = atoi(str);
	}else{
		m_LcdGridRgb = atoi(DEFAULT_LCD_GRID);
	}
	m_LcdGrid.Format("RGB( %d, %d, %d )",
		m_LcdGridRgb & 0x000000FF,
		(m_LcdGridRgb & 0x0000FF00) >> 8,
		(m_LcdGridRgb & 0x00FF0000) >> 16
		);	

	GetPrivateProfileString("Setting","LcdOn",DEFAULT_LCD_ON,str,256,P->m_ini);
	if( strcmp(str,"") != 0 ){
		m_LcdOnRgb = atoi(str);
	}else{
		m_LcdOnRgb = atoi(DEFAULT_LCD_ON);
	}
	m_LcdOn.Format("RGB( %d, %d, %d )",
		m_LcdOnRgb & 0x000000FF,
		(m_LcdOnRgb & 0x0000FF00) >> 8,
		(m_LcdOnRgb & 0x00FF0000) >> 16
		);

	GetPrivateProfileString("Setting","LcdOff",DEFAULT_LCD_OFF,str,256,P->m_ini);
	if( strcmp(str,"") != 0 ){
		m_LcdOffRgb = atoi(str);
	}else{
		m_LcdOffRgb = atoi(DEFAULT_LCD_OFF);
	}
	m_LcdOff.Format("RGB( %d, %d, %d )",
		m_LcdOffRgb & 0x000000FF,
		(m_LcdOffRgb & 0x0000FF00) >> 8,
		(m_LcdOffRgb & 0x00FF0000) >> 16
		);

	m_LcdSample.SetNumberOfLines(2);
	m_LcdSample.SetXCharsPerLine(3);
	m_LcdSample.SetSize(CMatrixStatic::LARGE);
	m_LcdSample.SetDisplayColors( m_LcdGridRgb, m_LcdOnRgb, m_LcdOffRgb );
	m_LcdSample.AdjustClientYToSize(2);
	m_LcdSample.AdjustClientXToSize(3);
	m_LcdSample.DoScroll(500, CMatrixStatic::UP);
	m_LcdSample.SetAutoPadding(true);

	InitLcdSample(m_LcdSample1,LCD_GRID_1,LCD_ON_1,LCD_OFF_1);
	InitLcdSample(m_LcdSample2,LCD_GRID_2,LCD_ON_2,LCD_OFF_2);
	InitLcdSample(m_LcdSample3,LCD_GRID_3,LCD_ON_3,LCD_OFF_3);
	InitLcdSample(m_LcdSample4,LCD_GRID_4,LCD_ON_4,LCD_OFF_4);
	InitLcdSample(m_LcdSample5,LCD_GRID_5,LCD_ON_5,LCD_OFF_5);
	InitLcdSample(m_LcdSample6,LCD_GRID_6,LCD_ON_6,LCD_OFF_6);
	InitLcdSample(m_LcdSample7,LCD_GRID_7,LCD_ON_7,LCD_OFF_7);
	InitLcdSample(m_LcdSample8,LCD_GRID_8,LCD_ON_8,LCD_OFF_8);
	InitLcdSample(m_LcdSample9,LCD_GRID_9,LCD_ON_9,LCD_OFF_9);
	InitLcdSample(m_LcdSample10,LCD_GRID_10,LCD_ON_10,LCD_OFF_10);

//////////////////////////////////////////////
// Real Time Clock Setting
//////////////////////////////////////////////

	int i;
	CString cstr;
	GetPrivateProfileString("Setting","IntervalTime","1000",str,256,P->m_ini);
	if( atoi(str) <= 0 ){
		strcpy(str,"1000");
	}
	m_IntervalTime.AddString(str);
	m_IntervalTime.SetCurSel(0);
	for(i = 100;i< 1000;i+=100){
		cstr.Format("%d",i);
		m_IntervalTime.AddString(cstr);
	}
	for(i = 1000;i<= 10000;i+=1000){
		cstr.Format("%d",i);
		m_IntervalTime.AddString(cstr);
	}

	CButton* NoLoad = (CButton*)GetDlgItem(IDC_RTC_NO_LOAD);
	CButton* WithLoad = (CButton*)GetDlgItem(IDC_RTC_WITH_LOAD);

	GetPrivateProfileString("Setting","MethodType","0",str,256,P->m_ini);
	if( atoi(str) >= 1 ){
		WithLoad->SetCheck(1);
	}else{
		NoLoad->SetCheck(1);
	}

	GetPrivateProfileString("Setting","TopMost","1",str,256,P->m_ini);
	if( atoi(str) >= 1 ){
		m_RtcTopMost.SetCheck(1);
	}
	UpdateData(FALSE);

	return TRUE;
}

///////////////////////////////////////////////////////////////
// Background Image Setting
///////////////////////////////////////////////////////////////


void CCustomizeDlg::OnSelectFile() 
{
	CFileDialog dlg(TRUE,
		"","",
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_EXPLORER,
#ifdef USEJPEG
		"Supported Image Files|*.bmp;*.png;*.jpg;*.jpeg|BMP (*.bmp)|*.bmp|PNG (*.png)|*.png|JPEG (*.jpg *.jpeg)|*.jpg;*.jpeg|All Files (*.*)|*.*||");
//#else USEPNG
//		"Supported Image File|*.bmp;*.png|BMP (*.bmp)|*.bmp|PNG (*.png)|*.png|All Files (*.*)|*.*||");
#else 
		"Supported Image Files|*.bmp|BMP (*.bmp)|*.bmp|All Files (*.*)|*.*||");
#endif
	if( dlg.DoModal() == IDOK )
	{
		m_FileName = dlg.GetPathName();
		if( Dib.LoadBmp(m_FileName) 
#ifdef USEPNG
			|| Dib.LoadPng(m_FileName) 
#endif
#ifdef USEJPEG
		|| Dib.LoadJpeg(m_FileName)
#endif
		)
		{
			m_ImageSize.Format("%d x %d x %d", Dib.Width(), Dib.Height(), Dib.Depth() ) ;
			m_GrayC.EnableWindow( Dib.Depth() == 24 );
			Dib.Destroy();
		}
		UpdateData(FALSE);
		WritePrivateProfileString("Setting","BackgroundImage",m_FileName,P->m_ini);
		P->CreateWallPaper(1,NULL,(char*)(const char*)m_FileName,0,m_Gray);
		P->Invalidate();
	}
}

void CCustomizeDlg::OnSelectColor() 
{
	CColorDialog dlg;
	if( dlg.DoModal() == IDOK )
	{
		gTextColor = dlg.GetColor();
		m_TextColor.Format("RGB( %d, %d, %d )",
			gTextColor & 0x000000FF,
			(gTextColor & 0x0000FF00) >> 8,
			(gTextColor & 0x00FF0000) >> 16
			);
		UpdateData(FALSE);

		CString cstr;
		cstr.Format("%d",gTextColor);
		WritePrivateProfileString("Setting","TextColor",cstr,P->m_ini);
		P->Invalidate();
	}
}

void CCustomizeDlg::OnClear() 
{
	WritePrivateProfileString("Setting","BackgroundImage","",P->m_ini);
	WritePrivateProfileString("Setting","TextColor","",P->m_ini);
	WritePrivateProfileString("Setting","Gray","",P->m_ini);
	
	gTextColor = ::GetSysColor(COLOR_WINDOWTEXT);
	m_TextColor.Format("RGB( %d, %d, %d )",
		gTextColor & 0x000000FF,
		(gTextColor & 0x0000FF00) >> 8,
		(gTextColor & 0x00FF0000) >> 16
		);
	m_FileName = "";
	m_ImageSize = "";
	m_Gray = FALSE;

	UpdateData(FALSE);

	P->CreateWallPaper(1,NULL,(char*)(const char*)m_FileName,0,FALSE);
	P->Invalidate();
}

void CCustomizeDlg::OnGray() 
{
	UpdateData(TRUE);
	CString cstr;
	cstr.Format("%d",m_Gray);
	WritePrivateProfileString("Setting","Gray",cstr,P->m_ini);
	P->CreateWallPaper(1,NULL,(char*)(const char*)m_FileName,0,m_Gray);
	P->Invalidate();
}

///////////////////////////////////////////////////////////////
// Select LCD Color
///////////////////////////////////////////////////////////////

void CCustomizeDlg::OnSelectLcdOn() 
{
	SelectLcdColor(m_LcdOnRgb, m_LcdOn, "LcdOn");
}

void CCustomizeDlg::OnSelectLcdOff() 
{
	SelectLcdColor(m_LcdOffRgb, m_LcdOff, "LcdOff");	
}

void CCustomizeDlg::OnSelectLcdGrid() 
{
	SelectLcdColor(m_LcdGridRgb, m_LcdGrid, "LcdGrid");
}

void CCustomizeDlg::SelectLcdColor(COLORREF &color, CString &ctrl, CString section)
{
	CColorDialog dlg;
	if( dlg.DoModal() == IDOK )
	{
		color = dlg.GetColor();
		SetLcdColor(color, ctrl, section);
	}
}

void CCustomizeDlg::SetLcdColor(COLORREF &color, CString &ctrl, CString section)
{
	ctrl.Format("RGB( %d, %d, %d )",
		color & 0x000000FF,
		(color & 0x0000FF00) >> 8,
		(color & 0x00FF0000) >> 16
		);
	UpdateData(FALSE);
	m_LcdSample.SetDisplayColors( m_LcdGridRgb, m_LcdOnRgb, m_LcdOffRgb );

	CString cstr;
	cstr.Format("%d",color);
	WritePrivateProfileString("Setting",section,cstr,P->m_ini);

	if( P->m_RealTimeClockDlg != NULL ){
		P->m_RealTimeClockDlg->m_Clock.SetDisplayColors( m_LcdGridRgb, m_LcdOnRgb, m_LcdOffRgb );
	}
}

///////////////////////////////////////////////////////////////
// Interval Time
///////////////////////////////////////////////////////////////

void CCustomizeDlg::OnSelchangeIntervalTime() 
{
	CString cstr;
	m_IntervalTime.GetLBText(m_IntervalTime.GetCurSel(),cstr);
	WritePrivateProfileString("Setting","IntervalTime",cstr,P->m_ini);
	if( P->m_RealTimeClockDlg != NULL ){
		P->m_RealTimeClockDlg->ChangeIntervalTime(atoi(cstr));
	}
}

///////////////////////////////////////////////////////////////
// Method Type
///////////////////////////////////////////////////////////////

void CCustomizeDlg::OnRtcHelp() 
{
	CString cstr;
	if( gLanguage == JAPANESE ){
cstr = "\
NbNmɑłȂꍇ̂ With Load IĂB\r\n\
኱ׂ͑܂ANbNmɑł悤ɂȂ͂łB\
";
	}else{
cstr = "\
Only when clock cannot measure correctly, Please choose With Load.\r\n\
Although load increases a little, clock can measure correctly.\
";
	}
	MessageBox(cstr);
}

void CCustomizeDlg::OnRtcNoLoad() 
{
	WritePrivateProfileString("Setting","MethodType","0",P->m_ini);
	if( P->m_RealTimeClockDlg != NULL ){
		P->m_RealTimeClockDlg->ChangeMethodType(0);
	}
}

void CCustomizeDlg::OnRtcWithLoad() 
{
	WritePrivateProfileString("Setting","MethodType","1",P->m_ini);
	if( P->m_RealTimeClockDlg != NULL ){
		P->m_RealTimeClockDlg->ChangeMethodType(1);
	}	
}

///////////////////////////////////////////////////////////////
// Setup Lcd Sample Color
///////////////////////////////////////////////////////////////

void CCustomizeDlg::SetupLcdSampleColor( COLORREF grid, COLORREF on, COLORREF off )
{
	m_LcdGridRgb = grid;
	m_LcdOnRgb   = on;
	m_LcdOffRgb  = off;
	SetLcdColor(m_LcdGridRgb, m_LcdGrid, "LcdGrid");
	SetLcdColor(m_LcdOnRgb, m_LcdOn, "LcdOn");
	SetLcdColor(m_LcdOffRgb, m_LcdOff, "LcdOff");
}

void CCustomizeDlg::OnLcdSample1() 
{
	SetupLcdSampleColor(LCD_GRID_1,LCD_ON_1,LCD_OFF_1);
}

void CCustomizeDlg::OnLcdSample2() 
{
	SetupLcdSampleColor(LCD_GRID_2,LCD_ON_2,LCD_OFF_2);	
}

void CCustomizeDlg::OnLcdSample3() 
{
	SetupLcdSampleColor(LCD_GRID_3,LCD_ON_3,LCD_OFF_3);
}

void CCustomizeDlg::OnLcdSample4() 
{
	SetupLcdSampleColor(LCD_GRID_4,LCD_ON_4,LCD_OFF_4);	
}

void CCustomizeDlg::OnLcdSample5() 
{
	SetupLcdSampleColor(LCD_GRID_5,LCD_ON_5,LCD_OFF_5);
}

void CCustomizeDlg::OnLcdSample6() 
{
	SetupLcdSampleColor(LCD_GRID_6,LCD_ON_6,LCD_OFF_6);	
}

void CCustomizeDlg::OnLcdSample7() 
{
	SetupLcdSampleColor(LCD_GRID_7,LCD_ON_7,LCD_OFF_7);
}

void CCustomizeDlg::OnLcdSample8() 
{
	SetupLcdSampleColor(LCD_GRID_8,LCD_ON_8,LCD_OFF_8);
}

void CCustomizeDlg::OnLcdSample9() 
{
	SetupLcdSampleColor(LCD_GRID_9,LCD_ON_9,LCD_OFF_9);
}

void CCustomizeDlg::OnLcdSample10() 
{
	SetupLcdSampleColor(LCD_GRID_10,LCD_ON_10,LCD_OFF_10);
}

void CCustomizeDlg::OnRtcTopmost() 
{
	CString cstr;
	cstr.Format("%d", m_RtcTopMost.GetCheck() );
	WritePrivateProfileString("Setting","TopMost",cstr,P->m_ini);
	if( P->m_RealTimeClockDlg != NULL ){
		if( m_RtcTopMost.GetCheck() ){
			::SetWindowPos(P->m_RealTimeClockDlg->m_hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE); 
		}else{
			::SetWindowPos(P->m_RealTimeClockDlg->m_hWnd,HWND_NOTOPMOST,0,0,0,0,SWP_NOMOVE | SWP_NOSIZE); 
		}
	}		
}
