/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/
#include "stdafx.h"
#include "GetOSInfo.h"

void GetOSInfo(CString& OSName,CString& OSType,CString& OSCSD,CString& OSVersion,CString& OSBuild,CString& OSInfo)
{
	CString cstr;
	OSVERSIONINFOEX osvi;
	BOOL bOsVersionInfoEx;

	ZeroMemory(&osvi, sizeof(OSVERSIONINFOEX));
	osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFOEX);
	if( !(bOsVersionInfoEx = GetVersionEx ((OSVERSIONINFO *) &osvi)) )
	{
		osvi.dwOSVersionInfoSize = sizeof (OSVERSIONINFO);
		GetVersionEx( (OSVERSIONINFO *) &osvi);
	}

	switch(osvi.dwPlatformId)
	{
	case VER_PLATFORM_WIN32_WINDOWS:

		switch( osvi.dwMinorVersion ){
		case 0: // Windows 95
			if( LOWORD(osvi.dwBuildNumber) < 1000 ){
				OSName = "Windows 95";	
			}else if( LOWORD(osvi.dwBuildNumber) >= 1214 ){
				OSName = "Windows 95 OSR2.5";
			}else if( LOWORD(osvi.dwBuildNumber) >= 1212 ){
				OSName = "Windows 95 OSR2.1";
			}else if( LOWORD(osvi.dwBuildNumber) == 1111 ){
				OSName = "Windows 95 OSR2";
			}else{
				OSName = "Windows 95";	
			}
			break;
		case 10: // Windows 98
			if( LOWORD(osvi.dwBuildNumber) == 1998 ){
				OSName = "Windows 98";	
			}else if( LOWORD(osvi.dwBuildNumber) >= 2222 ){
				OSName = "Windows 98 SE";
			}else if( LOWORD(osvi.dwBuildNumber) >= 2000 ){
				OSName = "Windows 98 SP1";
			}else{
				OSName = "Windows 98";	
			}
			break;
		case 90:
			OSName = "Windows Me";
			break;
		default:
			OSName = "Windows 9x";
			break;
		}

		OSVersion.Format("%d.%d",osvi.dwMajorVersion,osvi.dwMinorVersion);
		OSBuild.Format("%d",LOWORD(osvi.dwBuildNumber)); 
		break;

	case VER_PLATFORM_WIN32_NT:
		if(osvi.dwMajorVersion == 3){
			OSName.Format("Windows NT3.%d",osvi.dwMinorVersion);
		}else if(osvi.dwMajorVersion == 4 && osvi.dwMinorVersion == 0){
			OSName = "Windows NT4";
		}else if(osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 0){
			OSName = "Windows 2000";
		}else if(osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 1){
			OSName = "Windows XP";
		}else if(osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 2){
			OSName = "Windows Server 2003";
		}else if(osvi.dwMajorVersion == 6 && osvi.dwMinorVersion == 0){
			OSName = "Windows NT6.0 (Longhorn)";
		}else{
			OSName.Format("Windows NT%d.%d",osvi.dwMajorVersion,osvi.dwMinorVersion);
		}

		if(! (osvi.dwMajorVersion == 5 && osvi.dwMinorVersion == 2) ){
			if( bOsVersionInfoEx ){
				if( osvi.wProductType == VER_NT_WORKSTATION ){
					if( osvi.wSuiteMask & VER_SUITE_PERSONAL ){
						OSType = "Home";
					}else{
						if(osvi.dwMajorVersion == 5){OSType = "Professional";}
						else if(osvi.dwMajorVersion == 4){OSType = "Workstation";}
					}
				}else if( osvi.wProductType == VER_NT_SERVER ){
					if( osvi.wSuiteMask & VER_SUITE_DATACENTER ){
						OSType = "DataCenter Server";
					}else if( osvi.wSuiteMask & VER_SUITE_ENTERPRISE ){
						OSType = "Advanced Server";
					}else{
						OSType = "Server";
					}
				}
			}else{// NT4 SP5
					HKEY hKey;
					char szProductType[80];
					DWORD dwBufLen;
					RegOpenKeyEx( HKEY_LOCAL_MACHINE,
						"SYSTEM\\CurrentControlSet\\Control\\ProductOptions",
						0, KEY_QUERY_VALUE, &hKey );
					RegQueryValueEx( hKey, "ProductType", NULL, NULL,
						(LPBYTE) szProductType, &dwBufLen);
					RegCloseKey( hKey );
					if( lstrcmpi( "WINNT", szProductType) == 0 ){OSType = "Workstation";}
					if( lstrcmpi( "LANMANNT", szProductType) == 0 ){OSType = "Server";}
					if( lstrcmpi( "SERVERNT", szProductType) == 0 ){OSType = "Advanced Server";}
			 }
		}

		OSCSD = osvi.szCSDVersion;
		//OSCSD.Replace("Service Pack ","SP");

		OSVersion.Format("%d.%d",osvi.dwMajorVersion,osvi.dwMinorVersion);
		OSBuild.Format("%d",osvi.dwBuildNumber);
				 
		break;
	}
	if( ! OSCSD.IsEmpty() ){
		OSInfo = OSName + " " + OSCSD;
	}else{
		OSInfo = OSName;
	}
}